//+------------------------------------------------------------------+
//|                                            Probability Index.mq4 |
//|                                                         basefree |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "basefree"
#property link      ""

#property indicator_separate_window
#property indicator_minimum -1.0
#property indicator_maximum 1.0
#property indicator_buffers 1
#property indicator_color1 Red
extern int Quant_Bars=200;
//---- buffers
double ExtMapBuffer1[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,ExtMapBuffer1);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int i,q,counted_bars=IndicatorCounted();
//----
   i=Bars-counted_bars-1;
   int PosBars=0;
   int NegBars=0;
   
   for(q=0;q<=i;q++)
   {
      if(Open[q]<Close[q])
         PosBars++;
      if(Open[q]>Close[q])
         NegBars++;
   }
   
   double ProbabilityPos=PosBars/i;
   
   while(i>=0)
     {
      int PosBars2=0;
      int NegBars2=0;
      
      if(Open[i]<Close[i])
      {
         PosBars2++;
         NegBars2=0;
         switch(PosBars2)
         {
            case '1':
               ExtMapBuffer1[i]=1-(ProbabilityPos);
               break;
            case '2':
               ExtMapBuffer1[i]=1-(ProbabilityPos*2);
               break;
            case '3':
               ExtMapBuffer1[i]=1-(ProbabilityPos*3);
               break;
            case '4':
               ExtMapBuffer1[i]=1-(ProbabilityPos*4);
               break;
            default:
               ExtMapBuffer1[i]=0.0;
               break;
         }
      }
      if(Open[i]>Close[i])
      {
         NegBars2++;
         PosBars2=0;
         switch(NegBars2)
         {
            case '1':
               ExtMapBuffer1[i]=-1+(ProbabilityPos);
               break;
            case '2':
               ExtMapBuffer1[i]=-1+(ProbabilityPos*2);
               break;
            case '3':
               ExtMapBuffer1[i]=-1+(ProbabilityPos*3);
               break;
            case '4':
               ExtMapBuffer1[i]=-1+(ProbabilityPos*4);
               break;
            default:
               ExtMapBuffer1[i]=0.0;
               break;
         }
      }
      if(i<Bars-1) ExtMapBuffer1[i]+=ExtMapBuffer1[i+1];
      i--;
     }   
//----
   return;
  }
//+------------------------------------------------------------------+